/* enemy.c */

#include <stdio.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "shot.h"
#include "enemy.h"

#define ENEMY_MAX	32	/* Gő吔 */

static ENEMY enemy[ENEMY_MAX];	/* [N */
static ENEMY *enemy_top,	/* gp̃[ÑXg */
 *enemy_null_top,		/* ̃[ÑXg */
 *enemy_end;			/* gp[ÑXg̖ */


/* ֐vg^Cv錾 */
void EnemyAllocA (ENEMY *);
int EnemyMoveA (ENEMY *);
void EnemyAllocB (ENEMY *);
int EnemyMoveB (ENEMY *);


/* ֐ւ̃|C^̔z */
typedef void (*enemy_alloc) (ENEMY *);
enemy_alloc EnemyAllocFunc[] =
{
	EnemyAllocA,
	EnemyAllocB,
};

/* ړ֐ւ̃|C^̔z */
typedef int (*enemy_move) (ENEMY *);
enemy_move EnemyMoveFunc[] =
{
	EnemyMoveA,
	EnemyMoveB,
};


/* ^Cv`̓G̏[` */
void EnemyAllocA (ENEMY * p)
{
	p->pt = obj_zako02 + 15;
	p->info = 0x0700 | PRIORITY_ZAKO;	/* l߂ē̂͂悭Ȃ */
	p->hit_sx = 12;		/* @Vbgɑ΂铖蔻 */
	p->hit_sy = 12;
	p->hp = 1;		/* ϋv */
	p->damage = 0;
}

/* ^Cv`̓G̈ړ[` */
/* ԂlFOȂ */
int EnemyMoveA (ENEMY * p)
{
	/* G邭񂷃Aj[V */
	p->pt--;
	if (p->pt < obj_zako02)
		p->pt = obj_zako02 + 15;

	/* wW@ɋ߂Â */
	if (p->lx > player->lx)
		p->lx -= 32768;
	else
		p->lx += 32768;

	p->ly += 2 * 65536;

	/* ʃ[hiŒ萮jo */
	p->x = p->lx >> 16;
	p->y = p->ly >> 16;

	if (p->y > 256 + 32)
		return (-1);	/* xW 256+32 ȏȂ */

	/* O_[W󂯂Ȃ */
	if (p->damage) {
		p->hp -= p->damage;
		p->damage = 0;
		if (p->hp <= 0)
			return (-1);	/* ϋv͂OȉȂ */
	}
	xobj_set_st (p);	/* \ */

	return (0);
}


/* ^Cva̓G̏[` */
void EnemyAllocB (ENEMY * p)
{
	p->pt = obj_zako02;
	p->info = 0x0800 | PRIORITY_ZAKO;	/* l߂ē̂͂悭Ȃ */
	p->hit_sx = 12;		/* @Vbgɑ΂铖蔻 */
	p->hit_sy = 12;
	p->hp = 2;		/* ϋv */
	p->damage = 0;
}

/* ^Cva̓G̈ړ[` */
/* ԂlFOȂ */
int EnemyMoveB (ENEMY * p)
{
	/* G邭񂷃Aj[V */
	p->pt++;
	if (p->pt > obj_zako02 + 15)
		p->pt = obj_zako02;


	/* wW@ɋ߂Â */
	if (p->lx > player->lx)
		p->lx -= 32768;
	else
		p->lx += 32768;

	p->ly += 2 * 65536;

	/* ʃ[hiŒ萮jo */
	p->x = p->lx >> 16;
	p->y = p->ly >> 16;

	if (p->y > 256 + 32)
		return (-1);	/* xW 256+32 ȏȂ */

	/* O_[W󂯂Ȃ */
	if (p->damage) {
		p->hp -= p->damage;
		p->damage = 0;
		if (p->hp <= 0)
			return (-1);	/* ϋv͂OȉȂ */
	}
	xobj_set_st (p);	/* \ */
	return (0);
}



/* Q[JnɌĂ΂ */
void EnemyInit (void)
{
	int i;

	/* XgȂ */
	enemy_top = NULL;
	enemy_end = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;
}



/* GoɌĂ΂ */
void EnemyAlloc (short type, signed short x, signed short y)
{
	ENEMY *p;

	if (enemy_null_top == NULL)
		return;		/* 󂫂̃[NȂiLN^[I[o[j */

	/* Xg̖ɐVm[hǉiƂ͈Ⴄ̂ŒӁj */
	p = enemy_null_top;
	enemy_null_top = p->next;
	if (enemy_top == NULL)
		enemy_top = p;
	else
		enemy_end->next = p;
	p->next = NULL;
	enemy_end = p;

	p->type = type;
	p->lx = x << 16;
	p->ly = y << 16;

	/* ֐ւ̃|C^gĕ */
	/* type  0 Ȃ EnemyAllocA() A1 Ȃ EnemyAllocB() s */
	EnemyAllocFunc[p->type] (p);

	return;
}



/* ƂɌĂ΂ */
void EnemyMove (void)
{
	ENEMY *p, *q;

	p = enemy_top;		/* ݒڂĂ郏[N */
	q = NULL;		/* PÕ[Ni[N폜ɕKvj */
	while (p != NULL) {
		/* GL̈ړ[` */

		/* ֐ւ̃|C^gĕ */
		/* type  0 Ȃ EnemyMoveA() A1 Ȃ EnemyMoveB() s */

		if (EnemyMoveFunc[p->type] (p)) {	/* ԂlOȂ */
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				enemy_top = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				q = NULL;
				p = enemy_top;
			} else {
				if (p == enemy_end) {	/* Xg̈ԍŌ폜 */
					q->next = NULL;
					enemy_end = q;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				} else {
					q->next = p->next;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				}
			}
		} else {
			/* GLȂꍇ */
			SHOT *p2 = shot_top;	/* ݒڂĂVbg̃[N */

			/* VbgƂ̓蔻 */
			while (p2 != NULL) {
				if ((p->x - p->hit_sx <= p2->x + p2->hit_x)
				    && (p->x + p->hit_sx >= p2->x - p2->hit_x)
				    && (p->y - p->hit_sy <= p2->y + p2->hit_y)
				    && (p->y + p->hit_sy >= p2->y - p2->hit_y)) {
					/* Vbg */
					p->damage++;	/* GLɃ_[W^ */
					p2->damage = !0;	/* @Vbgɓm点 */
				}
				p2 = p2->next;
			}
			q = p;
			p = p->next;
		}
	}
}
